// AlwaysCopyDll.h
#pragma once

typedef struct _OPTIONS_
{
    BOOL bAutoBegin;            //   
    BOOL bCopyDirTree;          //     (  )
    BOOL bRecurSearch;          //      (  )
    BOOL bCopyShortcutObjects;  //      (  )
    INT iPriority;              //    - THREAD_PRIORITY_XXX
    BOOL bCopyWindowOnTop;      //    
    INT iPrimaryLangID;         //     - LANG_RUSSIAN  LANG_ENGLISH.
} OPTIONS, *LPOPTIONS;

typedef struct _ELEMLISTFILEA_
{
    LPSTR lpszInputDir;
    LPSTR lpszInputFileName;
    LPSTR lpszOutDir;
} ELEMENTLISTFILEA, *LPELEMENTLISTFILEA;

typedef struct _ELEMLISTFILEW_
{
    LPWSTR lpszInputDir;        //      ( )
    LPWSTR lpszInputFileName;   //   
    LPWSTR lpszOutDir;          //    ( )
} ELEMENTLISTFILEW, *LPELEMENTLISTFILEW;

/*
 *    . Unicode .
 * :
 *      elf -   ELEMENTLISTFILEW;
 *      iCountElements -     elf;
 *      opt -  . bCopyDirTree, bRecurSearch, bCopyShortcutObjects - 
 *     (  ).
 *      hwndParent -   .   NULL.
 *  - 0.
 */
int WINAPI CopyFilesRestartableW(const LPELEMENTLISTFILEW elf, int iCountElements,const LPOPTIONS opt, HWND hwndParent = NULL);
/*
 *    . ANSI .
 *  ANSI-   Unicode. 
 *     CopyFilesRestartableW;
 *       
 *     - (AreFileApisANSI).
 */
int WINAPI CopyFilesRestartableA(const LPELEMENTLISTFILEA elf, int iCountElements,const LPOPTIONS opt, HWND hwndParent = NULL);

/*
 *      .
 *    (TRUE - lpszPath    ).
 */
BOOL ResolveShortcutW(LPCWSTR lpszLinkFile, LPWSTR lpszPath);
BOOL ResolveShortcutA(LPCSTR lpszLinkFile, LPSTR lpszPath);

/*
 *   .
 *      .
 */
int InitAlwaysCopyDllAPI();
/*
 *   .
 *     .
 */
int UnInitAlwaysCopyDllAPI();

#ifdef _UNICODE

typedef ELEMENTLISTFILEW ELEMENTLISTFILE;
typedef LPELEMENTLISTFILEW LPELEMENTLISTFILE;
  
#define CopyFilesRestartable CopyFilesRestartableW
#define ResolveShortcut ResolveShortcutW

#else // _UNICODE

typedef ELEMENTLISTFILEA ELEMENTLISTFILE;
typedef LPELEMENTLISTFILEA LPELEMENTLISTFILE;

#define CopyFilesRestartable CopyFilesRestartableA
#define ResolveShortcut ResolveShortcutA
#endif // _UNICODE
